/******************************************************************************/
//    File Name     : Model3.java
//                            Java Applet source file
//    Name          : Yoshiyuki Tanaka
//                    (e-Mail : tanaka_y@jaist.ac.jp)
//    Class Name    :     1.Model3()
/******************************************************************************/

/******************************************************************************/
//                                  IMPORT
/******************************************************************************/
import java.awt.*;

/******************************************************************************/
//    Class Name    : Model3
/******************************************************************************/
public class Model3{

    /***** VALUE DATA *****/
    public    final  boolean     excite   = true;
    public    final  boolean     recovery = false;
    public    static Model3Param param    = new Model3Param();

    protected Dimension dim = new Dimension(0, 0);
    protected boolean   u   = recovery;
    protected boolean   ut  = recovery;
    protected int       v   = 0;
    protected int       vt  = 0;

    /***** CONSTRUCTOR *****/
    Model3(boolean _u, int _v) { this.u = this.ut = _u; this.v = this.vt = _v; }

    Model3(boolean _u){ this(   _u, 0) ;}
    Model3()          { this(false, 0) ;}

    /***** METHOD DATA *****/
    /**************************************************************************/
    //    Method Name   : reset()
    /**************************************************************************/
    protected void  reset() { this.u = this.ut = recovery; this.v = this.vt = 0; }

    /**************************************************************************/
    //    Method Name   : set
    /**************************************************************************/
    protected void setCell(boolean _u, int _v)
    { this.u = this.ut = _u; this.v = this.vt = _v; }

    protected void setdim(){
        this.dim.width  = (int)( param.getd() * Math.random() );
        this.dim.height = (int)( param.getd() * Math.random() );
    }

    /**************************************************************************/
    //    Method Name   : step()
    /**************************************************************************/
    protected void step(){
        // 1)
        if(  (!u)&&( Math.random() <= param.getp() )  ) u = excite;
        // 2)
        if(v >= 1) v--;
        // 3)
        if(u) v += param.getw1();
        ut = u;
        vt = v;
    }

    /**************************************************************************/
    //    Method Name   : renewalState()
    /**************************************************************************/
    protected void renewalState(int _v, int avr)
    {
        // 4)'
        if(  _v > (param.getm0() + param.getm() * v) ) u = excite;
        // 5)'
        v = avr;
        // 6)'
        if( (u)&&( v > param.getw2() ) ) u = recovery;
    }

    /**************************************************************************/
    //    Method Name   : checkExcited()
    //    Method Name   : get_v()
    /**************************************************************************/
    public boolean   checkExcited(){ return this.ut; }
    public int       getv()  { return this.vt; }
    public Dimension getdim(){ return this.dim; }

    /**************************************************************************/
    //    Method Name   : getColor()
    /**************************************************************************/
    public Color getColor()
    {
        int level = 255;
        int max  = param.getw2() + param.getw1();

        if( this.v < max )
            level = (int)( (250 * this.v)/ max );
        else
            level = 255;

        if(u){
            level = 255 - level;
            return new Color( level, 0, 0 );
        }else
            return new Color( 0, 0, level );
    }

}


/**** END_of_file: Model3.java **************************************************/
