/******************************************************************************/
//    File Name     : Model3s.java
//                            Java Applet source file
//    Name          : Yoshiyuki Tanaka
//                    (e-Mail : tanaka_y@jaist.ac.jp)
//    Class Name    :     1.Model3s()
/******************************************************************************/

/******************************************************************************/
//                                  IMPORT
/******************************************************************************/
import java.awt.*;

/******************************************************************************/
//    Class Name    : Model3s
/******************************************************************************/

public class Model3s
{
    /***** VALUE DATA *****/
    protected static Dimension   dim   = new Dimension(200, 200);
    protected static int         time  = 0;

    public    static Model3Param param = new Model3Param();
    public    static Model3[][]  cell  = new Model3[dim.height][dim.width];

    /***** CONSTRUCTOR *****/
    public Model3s(){
        for(int i = 0; i < cell.length; i++)
            for(int j = 0; j < cell[i].length; cell[i][j++] = new Model3() );
    }

    /***** METHOD DATA *****/
    /**************************************************************************/
    //    Method Name   : reset()
    /**************************************************************************/
    public void reset(){
        for(int i = 0; i < cell.length; i++)
            for(int j = 0; j < cell[i].length; cell[i][j++].reset() );
        time = 0;
    }


    /**************************************************************************/
    //    Method Name   : grow()
    /**************************************************************************/
    public void grow(){
        int Ru = param.getRu();
        int Rv = param.getRv();
        int d =  param.getd();
        int ru = (int)(Ru/d) + 1;
        int rv = (int)(Rv/d) + 1;
        int r = (ru > rv)? ru: rv;

        for(int i = 0; i < cell.length; i++)
            for(int j = 0; j < cell[i].length; cell[i][j++].step() );

        for(int i = 0; i < cell.length; i++){
            for(int j = 0; j < cell[i].length; j++){

                int v       = 0;
                int v_cnt   = 0;
                int sigma_v = 0;
                cell[i][j].setdim();
                int x0 = cell[i][j].getdim().width;
                int y0 = cell[i][j].getdim().height;

                for(int ri = -r; ri <= r; ri++){
                    if(  ( (i + ri) < 0 )||( cell.length <= (i + ri) )  ) continue;

                    for(int rj = -r; rj <= r; rj++){
                        if(  ( (j + rj) < 0 )||( cell[i].length <= (j + rj) )  ) continue;

                        int x1 = cell[i + ri][j + rj].getdim().width;
                        int y1 = cell[i + ri][j + rj].getdim().height;
                        int x = (ri < 0)?(x0 - x1 - ri * d):(x1 - x0 + ri * d);
                        int y = (rj < 0)?(y1 - y0 - rj * d):(y1 - y0 + rj * d);

                        if( (x*x + y*y) <= Ru*Ru )
                            if( cell[i + ri][j + rj].checkExcited() ) v++;

                        if( (x*x + y*y) <= Rv*Rv ){
                            sigma_v += cell[i + ri][j + rj].getv();
                            v_cnt++;
                        }
                    }
                }
                int avr = (v_cnt != 0)?(int)(sigma_v/v_cnt): 0;
                if(v_cnt != 0)
                    avr = (avr == (sigma_v/v_cnt) )?(avr):(avr+1);
                else
                    avr = 0;
                cell[i][j].renewalState(v, avr);
            }
        }
        this.time++;
    }

    /**************************************************************************/
    //    Method Name   : getdim()
    //    Method Name   : gettime()
    /**************************************************************************/
    public Dimension getdim() { return dim ;}
    public int       gettime(){ return time ;}

}


/**** END_of_file: Model3s.java *************************************************/
